#include "Lgi.h"

////////////////////////////////////////////////////////////////////////////
int32 ThreadEntryPoint(void *i)
{
	if (i)
	{
		GThread *Thread = (GThread*) i;
		Thread->OnBeforeMain();
		Thread->ReturnValue = Thread->Main();
		Thread->OnAfterMain();
		Thread->State = LGITHREAD_EXITED;
		return Thread->ReturnValue;
	}
	return 0;
}

GThread::GThread()
{
	State = LGITHREAD_ASLEEP;
	ReturnValue = -1;
}

GThread::~GThread()
{
	if (NOT IsExited())
	{
		Terminate();
	}
}

int GThread::Priority()
{
	return 0;
}

void GThread::Priority(int p)
{
}

int GThread::ExitCode()
{
	return ReturnValue;
}

bool GThread::IsExited()
{
	return State == LGITHREAD_EXITED;
}

bool GThread::IsRunning()
{
	return State == LGITHREAD_RUNNING;
}

void GThread::Run(bool b)
{
	if (b)
	{
		State = LGITHREAD_RUNNING;
		OnRun(b);
	}
	else
	{
		OnRun(b);
		State = LGITHREAD_ASLEEP;
	}
}

void GThread::Terminate()
{
	State = LGITHREAD_EXITED;
}

int GThread::Main()
{
	return 0;
}

