// BeOS Clipboard Implementation
#include "Lgi.h"
#include "Clipboard.h"

///////////////////////////////////////////////////////////////////////////////////////////////
GClipBoard::GClipBoard(GView *o)
{
	Owner = o;
	Open = be_clipboard != 0;
}

GClipBoard::~GClipBoard()
{
}

bool GClipBoard::Empty()
{
	bool Status = false;
	
	if (be_clipboard AND
		be_clipboard->Lock())
	{
		be_clipboard->Clear();
		be_clipboard->Unlock();
		Status = true;
	}
	
	return Status;
}

bool GClipBoard::Text(char *Str)
{
	bool Status = false;
	
	if (Str AND
		be_clipboard AND
		be_clipboard->Lock())
	{
		be_clipboard->Clear();
		
		BMessage *Clip = be_clipboard->Data();
		if (Clip)
		{
			Clip->AddData("text/plain", B_MIME_TYPE, Str, strlen(Str));
			be_clipboard->Commit();
			Status = true;
		}
		
		be_clipboard->Unlock();
	}
	
	return Status;
}

char *GClipBoard::Text()
{
	char *Status = 0;
	
	if (be_clipboard AND
		be_clipboard->Lock())
	{
		BMessage *Clip = be_clipboard->Data();
		if (Clip)
		{
			char *Str = 0;
			ssize_t Len = 0;
			if (Clip->FindData("text/plain", B_MIME_TYPE, (const void **)&Str, &Len) == B_OK)
			{
				Status = NewStr(Str);
			}
			
			be_clipboard->Commit();
		}
		
		be_clipboard->Unlock();
	}
	
	return Status;
}

bool GClipBoard::Bitmap(GSurface *pDC)
{
	bool Status = FALSE;
	if (pDC)
	{
	}
	return Status;
}

GSurface *GClipBoard::Bitmap()
{
	return 0;
}

bool GClipBoard::Binary(int Format, uchar *Ptr, int Len)
{
	bool Status = false;

	if (Ptr AND Len > 0)
	{
	}

	return Status;
}

bool GClipBoard::Binary(int Format, uchar **Ptr, int *Len)
{
	bool Status = false;

	if (Ptr AND Len)
	{
	}

	return Status;
}

