// Applicator stuff


// servers
class LgiClass GdcSetServer : public GdcApplicatorServer {
public:
	int Op() { return GDC_SET; }
	GApplicator *Create(int Bits);
};

class LgiClass GdcAndServer : public GdcApplicatorServer {
public:
	int Op() { return GDC_AND; }
	GApplicator *Create(int Bits);
};

class LgiClass GdcOrServer : public GdcApplicatorServer {
public:
	int Op() { return GDC_OR; }
	GApplicator *Create(int Bits);
};

class LgiClass GdcXorServer : public GdcApplicatorServer {
public:
	int Op() { return GDC_XOR; }
	GApplicator *Create(int Bits);
};


// 8 bit applicators
class LgiClass GdcApp8 : public GApplicator {
protected:
	uchar *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class LgiClass GdcApp8Set : public GdcApp8 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp8And : public GdcApp8 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp8Or : public GdcApp8 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp8Xor : public GdcApp8 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

// 16 bit applicators
class LgiClass GdcApp16 : public GApplicator {
protected:
	uchar *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class LgiClass GdcApp16Set : public GdcApp16 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp16And : public GdcApp16 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp16Or : public GdcApp16 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp16Xor : public GdcApp16 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

// 24 bit applicators
class LgiClass GdcApp24 : public GApplicator {
protected:
	uchar *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class LgiClass GdcApp24Set : public GdcApp24 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp24And : public GdcApp24 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp24Or : public GdcApp24 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp24Xor : public GdcApp24 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

// 32 bit applicators
class LgiClass GdcApp32 : public GApplicator {
protected:
	ulong *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class LgiClass GdcApp32Set : public GdcApp32 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp32And : public GdcApp32 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp32Or : public GdcApp32 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp32Xor : public GdcApp32 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

#ifdef BEOS
// 15 bit applicators
class LgiClass GdcApp15 : public GApplicator {
protected:
	uchar *Ptr;

public:
	bool SetSurface(GdcSurface *d, GdcPalette *p, GdcSurface *a);
	void SetPtr(int x, int y);
	void IncX();
	void IncY();
	void IncPtr(int X, int Y);
	COLOUR Get();
};

class LgiClass GdcApp15Set : public GdcApp15 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp15And : public GdcApp15 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp15Or : public GdcApp15 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

class LgiClass GdcApp15Xor : public GdcApp15 {
public:
	void Set();
	void VLine(int height);
	void Rectangle(int x, int y);
	bool Blt(GdcSurface *Src, GdcPalette *SPal, GdcSurface *SrcAlpha);
};

#endif