#ifndef __DATE_TIME_H
#define __DATE_TIME_H

class LgiClass GDateTime : public GObject {

	int _Day;			// 1-DaysInMonth
	int _Month;			// 1-12
	int _Year;			// ####

	int _Thousands;		// 0-999
	int _Seconds;		// 0-59
	int _Minutes;		// 0-59
	int _Hours;			// 0-23		(24hr)

public:
	GDateTime();
	~GDateTime();

	// Date access
	int Day() { return _Day; }
	void Day(int d) { _Day = d; }
	int Month() { return _Month; }
	void Month(int m) { _Month = m; }
	int Year() { return _Year; }
	void Year(int y) { _Year = y; }

	// Time access
	int Thousands() { return _Thousands; }
	void Thousands(int t) { _Thousands = t; }
	int Seconds() { return _Seconds; }
	void Seconds(int s) { _Seconds = s; }
	int Minutes() { return _Minutes; }
	void Minutes(int m) { _Minutes = m; }
	int Hours() { return _Hours; }
	void Hours(int h) { _Hours = h; }

	// Misc
	void SetNow();
	void GetDate(char *Str);
	void GetTime(char *Str);
	void Get(char *Str);

	// Methods
	bool IsLeapYear(int Year = -1);
	int DaysInMonth(int Month, int Year = -1);
	void AddMinutes(int Minutes);
	void AddHours(int Hours);
	void AddDays(int Days);
	void AddMonths(int Months);
	
	// File
	int Sizeof();
	bool Serialize(GFile &f, bool Write);

	// operators
	bool operator <(GDateTime &dt);
	bool operator <=(GDateTime &dt);
	bool operator >(GDateTime &dt);
	bool operator >=(GDateTime &dt);
	bool operator ==(GDateTime &dt);
	bool operator !=(GDateTime &dt);
	int Compare(GDateTime *d);
};

#endif