/*hdr
**      FILE:           GXml.h
**      AUTHOR:         Matthew Allen
**      DATE:           4/9/99
**      DESCRIPTION:    General Xml Code
**
**      Copyright (C) 1999 Matthew Allen
**              fret@ozemail.com.au
*/

#ifndef __XML_H
#define __XML_H

#include "GFile.h"
#include "Contain.h"

//////////////////////////////////////////////////////////////////////////////////////
class LgiClass XmlValue {
public:
	char *Name;
	char *Value;

	XmlValue();
	XmlValue(char *&s);
	~XmlValue();
};

class LgiClass XmlTag {
public:
	char *Name;
	List<XmlValue> Values;

	XmlTag(char *&s);
	~XmlTag();

	bool Get(char *Name, char *&Value);
	bool Set(char *Name, char *Value);
};

class LgiClass Xml {
protected:
	StringPipe Str;
	
	char *Xml::ReadTextFile(char *FileName);
	virtual bool ProcessTag(XmlTag *Tag) { return false; }
	virtual bool ExpandXml(char *s, int *CursorIndex);

public:
	List<XmlTag> Values;
	int CursorX, CursorY;

	Xml();
	virtual ~Xml();
	int ParseXmlFile(GFile &File);
	int ParseXmlFile(char *FileName);
	int ParseXml(char *Data);
	char *NewStrFromXmlFile(GFile &File);
	char *NewStrFromXmlFile(char *FileName);
};

#endif