/*hdr
**      FILE:           GTabLayout.cpp
**      AUTHOR:         Matthew Allen
**      DATE:           28/6/99
**      DESCRIPTION:    Resizing Tab View
**
**      Copyright (C) 1999, Matthew Allen
**              fret@ozemail.com.au
*/

#include <stdio.h>

#include "Lgi.h"
#include "GTabLayout.h"

GTabLayout::GTabLayout() :
	GTabView(100, 0, 0, 100, 100, "GTabLayout")
{
}

GTabLayout::~GTabLayout()
{
}

bool GTabLayout::Pour(GComplexRegion &r)
{
	GRegion *Best = FindLargest(r);
	if (Best)
	{
		SetPos(*Best);
		return true;
	}
	return false;
}

void GTabLayout::OnPosChange()
{
	GTabView::OnPosChange();
	
	for (GTabPage *Page = Tabs.First(); Page; Page = Tabs.Next())
	{
		// GRegion Rgn(GetClient());
		GRegion Rgn(Page->GetPos());
		Rgn.Offset(-Rgn.x1, -Rgn.y1);
		GComplexRegion r(Rgn);

		for (GView *w = Page->Children.First(); w; w = Page->Children.Next())
		{
			GLayout *v = dynamic_cast<GLayout*>(w);
			if (v)
			{
				v->Pour(r);
			}
		}
	}
}

