// Basic tokeniser

#include <string.h>
#include "VMem.h"
#include "Contain.h"
#include "GToken.h"

/////////////////////////////////////////////////////////////////////////
bool IsNumber(char *p)
{
	if (p)
	{
		for (uint i=0; i<strlen(p); i++)
		{
			if ((p[i]<'0' OR p[i]>'9') AND p[i]!='-')
			{
				return false;
			}
		}
		return true;
	}
	return false;
}

char *Skip(char *p, char *Delimiter)
{
	while (p AND *p AND strchr(Delimiter, *p)) p++;
	return p;
}

////////////////////////////////////////////////////////////////////////
TokenParser::TokenParser()
{
	Token = 0;
	Tokens = 0;
}

TokenParser::TokenParser(char *Str, char *Delimiters)
{
	Token = 0;
	Tokens = 0;
	Parse(Str, Delimiters);
}

TokenParser::~TokenParser()
{
	Empty();
}

void TokenParser::Parse(char *Str, char *Delimiters)
{
	Empty();
	if (Str)
	{
		List<char> l;

		while (*Str)
		{
			Str = Skip(Str, Delimiters);
			if (*Str)
			{
				char *d = Delimiters;

				/*
				if (*Str == '\"')
				{
					d = "\"";
					Str++;
				}
				*/

				char *Start = Str;
				while (*Str AND NOT strchr(d, *Str)) Str++;
				char *t = NewStr(Start, (int)Str-(int)Start);
				if (t)
				{
					l.Insert(t);
				}

				/*
				if (*Str == '\"') Str++;
				*/
			}
		}

		Tokens = l.GetItems();
		if (Tokens > 0)
		{
			Token = NEW(char*[Tokens]);
			if (Token)
			{
				int i=0;
				for (char *t=l.First(); t; t=l.Next())
				{
					Token[i++] = t;
				}
			}
		}
	}
}

void TokenParser::Empty()
{
	if (Token)
	{
		for (int i=0; i<Tokens; i++)
		{
			DeleteArray(Token[i]);
		}
	}
	Token = 0;
	Tokens = 0;
}

void TokenParser::AppendTokens(TokenParser *T)
{
	if (T)
	{
		int Total = T->Tokens + Tokens;
		char **All = NEW(char*[Total]);
		if (All)
		{
			int i = 0;
			for (; i<Tokens; i++)
			{
				All[i] = Token[i];
			}
			for (; i<Total; i++)
			{
				All[i] = NewStr(T->Token[i-Tokens]);
			}
			DeleteArray(Token);
			Token = All;
			Tokens = Total;
		}
	}
}

char *TokenParser::Get(int i)
{
	if (i>=0 AND i<Tokens AND Token)
	{
		return Token[i];
	}
	return NULL;
}


