/*hdr
**      FILE:           GuiCommon.cpp
**      AUTHOR:         Matthew Allen
**      DATE:           15/10/2000
**      DESCRIPTION:    Common windows and controls
**
**      Copyright (C) 2000, Matthew Allen
**              fret@ozemail.com.au
*/

#include <stdio.h>
#include "Lgi.h"

///////////////////////////////////////////////////////////////////////////////////////////////////
GFileSelect::GFileSelect()
{
	Size = 4096;
	FileStr = NEW(char[Size]);
	if (FileStr)
	{
		*FileStr = 0;
	}
	else
	{
		Size = 0;
	}
}

GFileSelect::~GFileSelect()
{
	DeleteArray(FileStr);

	for (GFileType *Type = TypeList.First(); Type; Type = TypeList.Next())
	{
		DeleteObj(Type);
	}
}

char *GFileSelect::Name()
{
	return FileStr;
}

bool GFileSelect::Name(char *n)
{
	bool Status = FALSE;

	if (n AND FileStr)
	{
		strncpy(FileStr, n, Size);
	}

	return Status;
}

char *GFileSelect::operator [](int i)
{
	return NULL;
}

int GFileSelect::Names()
{
	return 1;
}

char *GFileSelect::File()
{
	return 0;
}

char *GFileSelect::Extension()
{
	return 0;
}

int GFileSelect::Types()
{
	return TypeList.GetItems();
}

int GFileSelect::SelectedType()
{
	return 0;
}

GFileType *GFileSelect::Type(int n)
{
	return (GFileType*) TypeList[n];
}

bool GFileSelect::Type(char *Description, char *Extension, int Data)
{
	GFileType *Type = NEW(GFileType);
	if (Type)
	{
		Type->Description(Description);
		Type->Extension(Extension);
		TypeList.Insert(Type);
	}

	return Type != 0;
}

GView *GFileSelect::Parent()
{
	return ParentWnd;
}

void GFileSelect::Parent(GView *Window)
{
	ParentWnd = Window;
	if (ParentWnd)
	{
	}
}

bool GFileSelect::MultiSelect()
{
	return 0;
}

void GFileSelect::MultiSelect(bool Multi)
{
}

char *GFileSelect::InitialDir()
{
	return 0;
}

void GFileSelect::InitialDir(char *InitDir)
{
}

char *GFileSelect::Title()
{
	return 0;
}

void GFileSelect::Title(char *Title)
{
}

char *GFileSelect::DefaultExtension()
{
	return 0;
}

void GFileSelect::DefaultExtension(char *DefExt)
{
}

bool GFileSelect::Open()
{
	bool Status = FALSE;

	return Status;
}

bool GFileSelect::OpenFolder()
{
	return 0;
}

bool GFileSelect::Save()
{
	bool Status = FALSE;
	return Status;
}

///////////////////////////////////////////////////////////////////////////////////////////////
GFindReplace::GFindReplace(GView *hParent)
{
}

GFindReplace::~GFindReplace()
{
}

void GFindReplace::SetParent(GView *hParent)
{
}

bool GFindReplace::OpenFind()
{
	return FALSE;
}

bool GFindReplace::OpenReplace()
{
	return FALSE;
}

int GFindReplace::OnEvent(GMessage *Msg)
{
	int Status = FALSE;

	return Status;
}

bool GFindReplace::OnFind()
{
	return TRUE;
}

bool GFindReplace::OnReplace()
{
	return TRUE;
}

bool GFindReplace::CaseSensitive()
{
	return 0;
}

void GFindReplace::CaseSensitive(bool i)
{
}

bool GFindReplace::WholeWord()
{
	return 0;
}

void GFindReplace::WholeWord(bool i)
{
}

bool GFindReplace::BtnFindNext()
{
	return 0;
}

bool GFindReplace::BtnReplace()
{
	return 0;
}

bool GFindReplace::BtnReplaceAll()
{
	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////
GClipBoard::GClipBoard(GView *o)
{
	Owner = o;
}

GClipBoard::~GClipBoard()
{
}

bool GClipBoard::Empty()
{
	return 0;
}

bool GClipBoard::Text(char *Str)
{
	return 0;
}

char *GClipBoard::Text()
{
	int Len = 0;
	return 0;
}

bool GClipBoard::Bitmap(GSurface *pDC)
{
	bool Status = FALSE;
	return Status;
}

/*
GSurface *GClipBoard::ConvertFromPtr(void *Ptr)
{
	GSurface *pDC = NULL;
	return pDC;
}
*/

GSurface *GClipBoard::Bitmap()
{
	return 0;
}

bool GClipBoard::Binary(int Format, uchar *Ptr, int Len)
{
	bool Status = FALSE;
	return Status;
}

bool GClipBoard::Binary(int Format, uchar **Ptr, int *Len)
{
	bool Status = false;
	return Status;
}

//////////////////////////////////////////////////////////////////////////////
GInput::GInput(GView *parent, char *InitStr, char *Msg, char *Title, bool Password)
{
	SetParent(parent);
	Str = 0;
	Pos.ZOff(300, 105);
	GView::Name(Title);
	MoveToCenter();
	Children.Insert(NEW(GText(-1, 5, 5, 280, 20, Msg)));
	Children.Insert(Edit = NEW(GEdit(200, 5, 30, 280, 20, InitStr)));
	if (Edit)
	{
		Edit->Password(Password);
	}
	GButton *Ok = 0;
	Children.Insert(Ok = NEW(GButton(IDOK, 150, 60, 60, 20, "Ok")));
	Children.Insert(NEW(GButton(IDCANCEL, 220, 60, 60, 20, "Cancel")));

	if (Ok)
	{
		Ok->Default(true);
	}
}

GInput::~GInput()
{
	DeleteArray(Str);
}

int GInput::OnNotify(GView *Ctrl, int Flags)
{
	switch (Ctrl->GetId())
	{
		case IDOK:
		{
			Str = NewStr(Edit->Name());
			// fall thru
		}
		case IDCANCEL:
		{
			EndModal(Ctrl->GetId() == IDOK);
			break;
		}
	}

	return 0;
}

