/*hdr
**      FILE:           Gui.cpp
**      AUTHOR:         Matthew Allen
**      DATE:           23/4/98
**      DESCRIPTION:    Memory subsystem
**
**      Copyright (C) 1998, Matthew Allen
**              fret@ozemail.com.au
*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>
#include "Lgi.h"
#include "base64.h"

////////////////////////////////////////////////////////////////////////////
int MouseRollMsg = 0;
#define SetKeyFlag(v, k, f)		if (GetKeyState(k)&0xFF00) { v |= f; }

////////////////////////////////////////////////////////////////////////////
bool LgiGetFileMimeType(char *File, char *Mime)
{
	return false;
}

bool LgiGetAppForMimeType(char *Mime, char *AppPath)
{
	return false;
}

int GetMouseWheelLines()
{
	return 3;
}

quad real_time_clock_usecs()
{
	quad Status = 0;
	struct timeval tp;
	if (gettimeofday(&tp, 0) == 0)
	{
		Status = (tp.tv_sec * 1000000) + tp.tv_usec;
	}
	return Status;
}

void _lgi_assert(bool b, char *test, char *file, int line)
{
	if (b)
	{
		printf("assert failed at %s (line %i)\n%s\n", file, line, test);
		exit(-1);
	}
}

GMessage CreateMsg(int Msg, int a, int b)
{
	GMessage m;
	m.Msg = Msg;
	m.a = a;
	m.b = b;
	return m;
}

//////////////////////////////////////////////////////////////////////////
int LgiRand(int i)
{
	return (rand() % i);
}

int LgiMsg(GView *Parent, char *Msg, char *Title, int Type, ...)
{
	int Result = 0;
	if (Msg)
	{
		char Buffer[4096];

		va_list Arg;
		va_start(Arg, Type);
		vsprintf(Buffer, Msg, Arg);
		va_end(Arg);

		Result = LgiMsg(Parent,
						Buffer,
						(Title)?Title:"Message",
						Type);
	}

	return Result;
}

bool LgiGetCursorPos(GdcPt2 *Pt, int *Buttons)
{
	bool Status = false;
	return Status;
}

bool LgiExecute(char *File, char *Arguments, char *Dir)
{
	return false;
}

bool LgiTrimDir(char *Path)
{
	char *Last = Path;
	char *p = strchr(Last, DIR_CHAR);
	if (p)
	{
		while (p = strchr(p+1, DIR_CHAR))
		{
			Last = p;
		}
		*Last = 0;
		return TRUE;
	}
	return FALSE;
}

bool LgiGetExeFile(char *Dst)
{
	return FALSE;
}

bool LgiGetExePath(char *Dst)
{
	if (Dst)
	{
		if (LgiGetExeFile(Dst))
		{
			LgiTrimDir(Dst);
			return true;
		}
	}
	return false;
}

char *LgiFindFile(char *Name)
{
	char *Result = 0;

	if (Name)
	{
		char *JustFile = Name + (strlen(Name) - 1);
		for (; JustFile>Name AND *JustFile != DIR_CHAR; JustFile--);
		if (JustFile > Name) JustFile++;

		#ifdef WIN32
		char ExePath[256];
		char File[256];
		if (LgiGetExePath(ExePath))
		{
			sprintf(File, "%s\\%s", ExePath, JustFile);
			if (FileExists(File))
			{
				Result = NewStr(File);
			}
			else
			{
				// ..
				strcpy(File, ExePath);
				LgiTrimDir(File);
				sprintf(File+strlen(File), "\\%s", JustFile);
				if (FileExists(File))
				{
					Result = NewStr(File);
				}
				else
				{
					// ..\\code
					strcpy(File, ExePath);
					LgiTrimDir(File);
					sprintf(File+strlen(File), "\\code\\%s", JustFile);
					if (FileExists(File))
					{
						Result = NewStr(File);
					}
				}
			}
		}
		#else if BEOS
		char ExePath[256];
		char File[256];
		if (LgiGetExePath(ExePath))
		{
			sprintf(File, "%s/%s", ExePath, JustFile);
			if (FileExists(File))
			{
				Result = NewStr(File);
			}
			else
			{
				// ..
				strcpy(File, ExePath);
				LgiTrimDir(File);
				sprintf(File+strlen(File), "/%s", JustFile);
				if (FileExists(File))
				{
					Result = NewStr(File);
				}
				else
				{
					// code
					strcpy(File, ExePath);
					sprintf(File+strlen(File), "/Code/%s", JustFile);
					if (FileExists(File))
					{
						Result = NewStr(File);
					}
				}
			}
		}
		#endif
	}

	return Result;
}

bool LgiPlaySound(char *FileName, int Flags)
{
	return false;
}

/////////////////////////////////////////////////////////////////////////////////////////////
void LgiDrawBox(GSurface *pDC, GRegion &r, bool Sunken, bool Fill)
{
	if (Fill)
	{
		pDC->Colour(TOOL_MED, 24);
		pDC->Rectangle(r.x1+1, r.y1+1, r.x2-1, r.y2-1);
	}

	pDC->Colour((Sunken) ? TOOL_HIGH : TOOL_LOW, 24);
	pDC->Line(r.x2, r.y2, r.x2, r.y1);
	pDC->Line(r.x2, r.y2, r.x1, r.y2);

	pDC->Colour((Sunken) ? TOOL_LOW : TOOL_HIGH, 24);
	pDC->Line(r.x1, r.y1, r.x1, r.y2);
	pDC->Line(r.x1, r.y1, r.x2, r.y1);
}

void LgiWideBorder(GSurface *pDC, GRegion &r, int Type)
{
	if (NOT pDC) return;
	COLOUR Old = pDC->Colour();
	COLOUR VLow = CBit(pDC->GetBits(), Rgb24(0, 0, 0));
	COLOUR Low = CBit(pDC->GetBits(), Rgb24(128, 128, 128));
	COLOUR High = CBit(pDC->GetBits(), Rgb24(192, 192, 192));
	COLOUR VHigh = CBit(pDC->GetBits(), Rgb24(255, 255, 255));

	switch (Type)
	{
		case SUNKEN:
		{
			pDC->Colour(Low);
			pDC->Line(r.x1, r.y1, r.x2-1, r.y1);
			pDC->Line(r.x1, r.y1, r.x1, r.y2-1);

			pDC->Colour(VLow);
			pDC->Line(r.x1+1, r.y1+1, r.x2-2, r.y1+1);
			pDC->Line(r.x1+1, r.y1+1, r.x1+1, r.y2-2);

			pDC->Colour(High);
			pDC->Line(r.x2-1, r.y2-1, r.x2-1, r.y1+1);
			pDC->Line(r.x2-1, r.y2-1, r.x1+1, r.y2-1);

			pDC->Colour(VHigh);
			pDC->Line(r.x2, r.y2, r.x2, r.y1);
			pDC->Line(r.x2, r.y2, r.x1, r.y2);
			break;
		}
		case RAISED:
		{
			pDC->Colour(VHigh);
			pDC->Line(r.x1, r.y1, r.x2-1, r.y1);
			pDC->Line(r.x1, r.y1, r.x1, r.y2-1);

			pDC->Colour(High);
			pDC->Line(r.x1+1, r.y1+1, r.x2-1, r.y1+1);
			pDC->Line(r.x1+1, r.y1+1, r.x1+1, r.y2-1);

			pDC->Colour(Low);
			pDC->Line(r.x2-1, r.y2-1, r.x2-1, r.y1+1);
			pDC->Line(r.x2-1, r.y2-1, r.x1+1, r.y2-1);

			pDC->Colour(VLow);
			pDC->Line(r.x2, r.y2, r.x2, r.y1);
			pDC->Line(r.x2, r.y2, r.x1, r.y2);
			break;
		}
		case CHISEL:
		{
			pDC->Colour(Low);
			pDC->Line(r.x1, r.y1, r.x2-1, r.y1);
			pDC->Line(r.x1, r.y1, r.x1, r.y2-1);

			pDC->Colour(VHigh);
			pDC->Line(r.x1+1, r.y1+1, r.x2-2, r.y1+1);
			pDC->Line(r.x1+1, r.y1+1, r.x1+1, r.y2-2);

			pDC->Colour(Low);
			pDC->Line(r.x2-1, r.y2-1, r.x2-1, r.y1+1);
			pDC->Line(r.x2-1, r.y2-1, r.x1+1, r.y2-1);

			pDC->Colour(VHigh);
			pDC->Line(r.x2, r.y2, r.x2, r.y1);
			pDC->Line(r.x2, r.y2, r.x1, r.y2);
			break;
		}
	}

	r.Size(2, 2);
	pDC->Colour(Old);
}

void LgiThinBorder(GSurface *pDC, GRegion &r, int Type)
{
	if (NOT pDC) return;
	COLOUR Old = pDC->Colour();

	switch (Type)
	{
		case SUNKEN:
		{
			pDC->Colour(TOOL_HIGH, 24);
			pDC->Line(r.x2, r.y2, r.x2, r.y1);
			pDC->Line(r.x2, r.y2, r.x1, r.y2);

			pDC->Colour(TOOL_LOW, 24);
			pDC->Line(r.x1, r.y1, r.x1, r.y2);
			pDC->Line(r.x1, r.y1, r.x2, r.y1);

			r.Size(1, 1);
			break;
		}
		case RAISED:
		{
			pDC->Colour(TOOL_LOW, 24);
			pDC->Line(r.x2, r.y2, r.x2, r.y1);
			pDC->Line(r.x2, r.y2, r.x1, r.y2);

			pDC->Colour(TOOL_HIGH, 24);
			pDC->Line(r.x1, r.y1, r.x1, r.y2);
			pDC->Line(r.x1, r.y1, r.x2, r.y1);

			r.Size(1, 1);
			break;
		}
	}

	pDC->Colour(Old);
}

void LgiFlatBorder(GSurface *pDC, GRegion &r, int Width)
{
	pDC->Colour(TOOL_MED, 24);
	if (Width < 1 OR r.X() < (2 * Width) OR r.Y() < (2 * Width))
	{
		pDC->Rectangle(&r);
		r.ZOff(-1, -1);
	}
	else
	{
		pDC->Rectangle(r.x1, r.y1, r.x2, r.y1+Width-1);
		pDC->Rectangle(r.x1, r.y2-Width+1, r.x2, r.y2);
		pDC->Rectangle(r.x1, r.y1+Width, r.x1+Width-1, r.y2-Width);
		pDC->Rectangle(r.x2-Width+1, r.y1+Width, r.x2, r.y2-Width);
		r.Size(Width, Width);
	}
}

////////////////////////////////////////////////////////////////////////////////////////////////////
GFlags::GFlags()
{
	WndFlags = GWF_VISIBLE | GWF_ENABLED;
}

bool GFlags::Enabled()
{
	return TestFlag(WndFlags, GWF_ENABLED);
}

void GFlags::Enabled(bool i)
{
	if (i) SetFlag(WndFlags, GWF_ENABLED);
	else ClearFlag(WndFlags, GWF_ENABLED);
}

bool GFlags::Visible()
{
	return TestFlag(WndFlags, GWF_VISIBLE);
}

void GFlags::Visible(bool i)
{
	if (i) SetFlag(WndFlags, GWF_VISIBLE);
	else ClearFlag(WndFlags, GWF_VISIBLE);
}

bool GFlags::Focus()
{
	return TestFlag(WndFlags, GWF_FOCUS);
}

void GFlags::Focus(bool i)
{
	if (i) SetFlag(WndFlags, GWF_FOCUS);
	else ClearFlag(WndFlags, GWF_FOCUS);
}

bool GFlags::DropTarget()
{
	return TestFlag(WndFlags, GWF_DROP_TARGET);
}

void GFlags::DropTarget(bool i)
{
	if (i) SetFlag(WndFlags, GWF_DROP_TARGET);
	else ClearFlag(WndFlags, GWF_DROP_TARGET);
}

#define GWF_ALL (GWF_SUNKEN | GWF_FLAT | GWF_RAISED)

bool GFlags::Sunken()
{
	return TestFlag(WndFlags, GWF_SUNKEN);
}

void GFlags::Sunken(bool i)
{
	WndFlags &= ~GWF_ALL;
	if (i) SetFlag(WndFlags, GWF_SUNKEN);
}

bool GFlags::Flat()
{
	return TestFlag(WndFlags, GWF_FLAT);
}

void GFlags::Flat(bool i)
{
	WndFlags &= ~GWF_ALL;
	if (i) SetFlag(WndFlags, GWF_FLAT);
}

bool GFlags::Raised()
{
	return TestFlag(WndFlags, GWF_RAISED);
}

void GFlags::Raised(bool i)
{
	WndFlags &= ~GWF_ALL;
	if (i) SetFlag(WndFlags, GWF_RAISED);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
GView::GView()
{
	CtrlId = -1;
	WndFlags = 0;
	Pos.ZOff(0, 0);
	Parent = 0;
	Notify = 0;
}

GView::~GView()
{
	// Delete myself out of my parent's list
	if (Parent)
	{
		Parent->Children.Delete(this);
	}

	// Delete all children
	GView *c;
	while (c = Children.First())
	{
		ASSERT(c->Parent == this);
		DeleteObj(c);
	}

	// Delete the OS representation of myself
	if (true)
	{
	}
	
	// NULL my handles and flags
	WndFlags = 0;

	// Remove static references to myself
	if (GApp::ObjInstance()->AppWnd == this)
	{
		GApp::ObjInstance()->AppWnd = 0;
	}
}

#define ADJ_LEFT			1
#define ADJ_RIGHT			2
#define ADJ_UP				3
#define ADJ_DOWN			4

int IsAdjacent(GRegion &a, GRegion &b)
{
	if (	(a.x1 == b.x2 + 1) AND
		NOT (a.y1 > b.y2 OR a.y2 < b.y1))
	{
		return ADJ_LEFT;
	}

	if (	(a.x2 == b.x1 - 1) AND
		NOT (a.y1 > b.y2 OR a.y2 < b.y1))
	{
		return ADJ_RIGHT;
	}

	if (	(a.y1 == b.y2 + 1) AND
		NOT (a.x1 > b.x2 OR a.x2 < b.x1))
	{
		return ADJ_UP;
	}

	if (	(a.y2 == b.y1 - 1) AND
		NOT (a.x1 > b.x2 OR a.x2 < b.x1))
	{
		return ADJ_DOWN;
	}

	return 0;
}

GRegion JoinAdjacent(GRegion &a, GRegion &b, int Adj)
{
	GRegion t;

	switch (Adj)
	{
		case ADJ_LEFT:
		case ADJ_RIGHT:
		{
			t.y1 = max(a.y1, b.y1);
			t.y2 = min(a.y2, b.y2);
			t.x1 = min(a.x1, b.x1);
			t.x2 = max(a.x2, b.x2);
			break;
		}
		case ADJ_UP:
		case ADJ_DOWN:
		{
			t.y1 = min(a.y1, b.y1);
			t.y2 = max(a.y2, b.y2);
			t.x1 = max(a.x1, b.x1);
			t.x2 = min(a.x2, b.x2);
			break;
		}
	}

	return t;
}

GRegion *GView::FindLargest(GComplexRegion &r)
{
	int Pixels = 0;
	GRegion *Best = 0;
	static GRegion Final;

	// do initial run through the list to find largest single region
	for (GRegion *i = r.First(); i; i = r.Next())
	{
		int Pix = i->X() * i->Y();
		if (Pix > Pixels)
		{
			Pixels = Pix;
			Best = i;
		}
	}

	if (Best)
	{
		Final = *Best;
		Pixels = Final.X() * Final.Y();

		int LastPixels = Pixels;
		GRegion LastRgn = Final;
		int ThisPixels = Pixels;
		GRegion ThisRgn = Final;

		GComplexRegion TempList;
		for (GRegion *i = r.First(); i; i = r.Next())
		{
			TempList.Union(i);
		}
		TempList.Subtract(Best);

		do
		{
			LastPixels = ThisPixels;
			LastRgn = ThisRgn;

			// search for adjoining rectangles that maybe we can add
			for (GRegion *i = TempList.First(); i; i = TempList.Next())
			{
				int Adj = IsAdjacent(ThisRgn, *i);
				if (Adj)
				{
					GRegion t = JoinAdjacent(ThisRgn, *i, Adj);
					int Pix = t.X() * t.Y();
					if (Pix > ThisPixels)
					{
						ThisPixels = Pix;
						ThisRgn = t;

						TempList.Subtract(i);
					}
				}
			}
		} while (LastPixels < ThisPixels);

		Final = ThisRgn;
	}

	return &Final;
}

GRegion *GView::FindSmallestFit(GComplexRegion &r, int Sx, int Sy)
{
	int X = 1000000;
	int Y = 1000000;
	GRegion *Best = 0;

	for (GRegion *i = r.First(); i; i = r.Next())
	{
		if (	(i->X() >= Sx AND i->Y() >= Sy) AND
			(i->X() < X OR i->Y() < Y))
		{
			X = i->X();
			Y = i->Y();
			Best = i;
		}
	}

	return Best;
}

GRegion *GView::FindLargestEdge(GComplexRegion &r, int Edge)
{
	GRegion *Best = 0;

	for (GRegion *i = r.First(); i; i = r.Next())
	{
		if (NOT Best)
		{
			Best = i;
		}

		if ((Edge & GV_EDGE_TOP) AND (i->y1 < Best->y1) OR
			(Edge & GV_EDGE_RIGHT) AND (i->x2 > Best->x2) OR
			(Edge & GV_EDGE_BOTTOM) AND (i->y2 > Best->y2) OR
			(Edge & GV_EDGE_LEFT) AND (i->x1 < Best->x1))
		{
			Best = i;
		}

		if (((Edge & GV_EDGE_TOP) AND (i->y1 == Best->y1) OR
			(Edge & GV_EDGE_BOTTOM) AND (i->y2 == Best->y2)) AND
			(i->X() > Best->X()))
		{
			Best = i;
		}

		if (((Edge & GV_EDGE_RIGHT) AND (i->x2 == Best->x2) OR
			(Edge & GV_EDGE_LEFT) AND (i->x1 == Best->x1)) AND
			(i->Y() > Best->Y()))
		{
			Best = i;
		}
	}

	return Best;
}

void GView::OnPosChange()
{
}

void GView::Quit(bool DontDelete)
{
}

bool GView::Enabled()
{
	return GFlags::Enabled();
}

void GView::Enabled(bool i)
{
	GFlags::Enabled(i);
}

bool GView::Visible()
{
	return GFlags::Visible();
}

void GView::Visible(bool i)
{
	GFlags::Visible(i);
}

bool GView::Focus()
{
	return false;
}

void GView::Focus(bool i)
{
}

bool GView::Sunken()
{
	return GFlags::Sunken();
}

void GView::Sunken(bool i)
{
	GFlags::Sunken(i);
}

bool GView::Flat()
{
	return GFlags::Flat();
}

void GView::Flat(bool i)
{
	GFlags::Flat(i);
}

bool GView::Raised()
{
	return GFlags::Raised();
}

void GView::Raised(bool i)
{
	GFlags::Raised(i);
}

int GView::GetCtrlValue(int CtrlId)
{
	return 0;
}

void GView::SetCtrlValue(int CtrlId, int i)
{
}

char *GView::GetCtrlName(int CtrlId)
{
	return 0;
}

void GView::SetCtrlName(int CtrlId, char *s)
{
}

bool GView::GetCtrlEnabled(int CtrlId)
{
	return false;
}

void GView::SetCtrlEnabled(int Ctrld, bool Enabled)
{
}

/*
bool GView::DropTarget()
{
	return TestFlag(WndExStyle, WS_EX_ACCEPTFILES);
	OnUpdateState();
}

void GView::DropTarget(bool t)
{
	if (t) SetFlag(WndExStyle, WS_EX_ACCEPTFILES);
	else ClearFlag(WndExStyle, WS_EX_ACCEPTFILES);
	OnUpdateState();
}
*/

void GView::SetId(int i)
{
	CtrlId = i;
}

bool GView::Attach(GView *p)
{
	bool Status = false;
	return Status;
}

bool GView::AttachChildren()
{
	return false;
}

bool GView::Detach()
{
	bool Status = FALSE;
	return Status;
}

GFontRef GView::GetFont()
{
	return 0;
}

void GView::SetFont(GFontRef hFont)
{
}

bool GView::IsOver(GMouse &m)
{
	return	(m.x >= 0) AND
			(m.y >= 0) AND
			(m.x < Pos.X()) AND
			(m.y < Pos.Y());
}

GView *GView::WindowFromPoint(int x, int y)
{
	for (GView *c = Children.First(); c; c = Children.Next())
	{
		GRegion r = c->GetPos();
		GView *Child = c->WindowFromPoint(x - r.x1, y - r.y1);
		if (Child)
		{
			return Child;
		}
	}

	if (x >= 0 AND y >= 0 AND x < Pos.X() AND y < Pos.Y())
	{
		return this;
	}

	return NULL;
}

bool GView::IsAttached()
{
	return false;
}

bool GView::IsCapturing()
{
	return false;
}

bool GView::GetMouse(GMouse &m, bool Client)
{
	return false;
}

GRegion &GView::GetClient()
{
	return Pos;
}

bool GView::Capture(bool c)
{
	return false;
}

bool GView::SetPos(GRegion &p, bool Repaint)
{
	bool Status = TRUE;
	Pos = p;
	return Status;
}

bool GView::Invalidate(GRegion *r, bool Repaint)
{
	return FALSE;
}

bool GView::InvalidateFrame(GRegion *r, bool Repaint)
{
	return FALSE;
}

void GView::SetPulse(int Length)
{
}

int GView::OnNotify(GView *Ctrl, int Flags)
{
	if (Ctrl AND Parent)
	{
		// default behaviour is just to pass the 
		// notification up to the parent
		return Parent->OnNotify(Ctrl, Flags);
	}

	return 0;
}

#define KEY_FLAGS		(~(MK_LBUTTON | MK_MBUTTON | MK_RBUTTON))

int GView::OnEvent(GMessage *Msg)
{
	return 0;
}

bool GView::Name(char *n)
{
	bool Status = GObject::Name(n);
	return TRUE;
}

char *GView::Name()
{
	return GObject::Name();
}

GView *GView::FindControl(OsView hCtrl)
{
	/*
	if (hWnd == hCtrl)
	{
		return this;
	}

	Iterator<GView> List(&Children);
	for (GView *c = List.First(); c; c = List.Next())
	{
		GView *Ctrl = c->FindControl(hCtrl);
		if (Ctrl)
		{
			return Ctrl;
		}
	}
	*/
	return 0;
}

GView *GView::FindControl(int Id)
{
	if (GetId() == Id)
	{
		return this;
	}

	Iterator<GView> List(&Children);
	for (GView *c = List.First(); c; c = List.Next())
	{
		GView *Ctrl = c->FindControl(Id);
		if (Ctrl)
		{
			return Ctrl;
		}
	}
	return 0;
}

void GView::MoveOnScreen()
{
	GRegion Screen(0, 0, GdcD->X()-1, GdcD->Y()-1);

	if (Pos.x2 >= Screen.X())
		Pos.Offset(Screen.X() - Pos.x2, 0);
	if (Pos.y2 >= Screen.Y())
		Pos.Offset(0, Screen.Y() - Pos.y2);
	if (Pos.x1 < 0)
		Pos.Offset(-Pos.x1, 0);
	if (Pos.y1 < 0)
		Pos.Offset(0, -Pos.y1);
}

void GView::MoveToCenter()
{
	GRegion Screen(0, 0, GdcD->X()-1, GdcD->Y()-1);
	Pos.Offset(-Pos.x1, -Pos.y1);
	Pos.Offset((Screen.X() - Pos.X()) / 2, (Screen.Y() - Pos.Y()) / 2);
}

void GView::MoveToMouse()
{
}

///////////////////////////////////////////////////////////////////////////////////////////////
GAppWindow::GAppWindow()
{
	Menu = 0;
}

GAppWindow::~GAppWindow()
{
	if (Menu)
	{
		Menu->Detach();
		DeleteObj(Menu);
	}
}

bool GAppWindow::Visible()
{
	return GView::Visible();
}

void GAppWindow::Visible(bool v)
{
	if (v) Pour();
	GView::Visible(v);
}

void GAppWindow::OnPaint(GSurface *pDC)
{
	pDC->Colour(LC_MED, 24);
	pDC->Rectangle();
}

void GAppWindow::Pour()
{
	GComplexRegion Client(Pos);
	GComplexRegion Update;

	for (GView *v = Children.First(); v; v = Children.Next())
	{
		GRegion OldPos = v->Pos;
		Update.Union(&OldPos);

		if (v->Pour(Client))
		{
			if (NOT v->Visible())
			{
				v->Visible(TRUE);
			}

			if (OldPos != v->Pos)
			{
				// position has changed update...
				v->Invalidate();
			}

			Client.Subtract(&v->Pos);
			Update.Subtract(&v->Pos);
		}
		else
		{
			// make the view not visible
			v->Visible(FALSE);
		}
	}

	for (int i=0; i<Update.GetSize(); i++)
	{
		Invalidate(Update[i]);
	}
}

int GAppWindow::OnEvent(GMessage *Msg)
{
	int Status = 0;

	switch (Message(Msg))
	{
		case WM_COMMAND:
		{
			Status = OnCommand(Msg->a & 0xFFFF, Msg->a>>16, (void*)Msg->b);
			break;
		}
		default:
		{
			Status = GView::OnEvent(Msg);
			break;
		}
	}

	return Status;
}

void GAppWindow::OnPosChange()
{
	Pour();
}

/////////////////////////////////////////////////////////////////////////////
GApp *GApp::TheApp = 0;
char *GApp::CmdLine = 0;

GApp::GApp(int Args, char **Arg)
{
	TheApp = this;
	AppWnd = 0;
	srand((unsigned)time(NULL));

	char Str[256] = "";
	for (int i=1; i<Args; i++)
	{
		if (strlen(Str) > 0)
		{
			strcat(Str, " ");
		}
		strcat(Str, Arg[i]);
	}
	CmdLine = NewStr(Str);

	SystemFont = NEW(GFont);
	if (SystemFont)
	{
		int Height, Width;

		if (GetOption(Str, 'l'))
		{
			Height = 7;
			Width = 5;
			strcpy(Str, "Verdana");
		}
		else
		{
			Height = 9;
			Width = 0;
			strcpy(Str, "Ms Sans Serif");
		}

		if (SystemFont->Create(Str, Height))
		{
			SystemFont->Fore(0);
			SystemFont->Transparent(TRUE);
		}
		else
		{
			// error: do what???
			printf("Error: Couldn't create system font\n");
		}
	}
}

GApp::~GApp()
{
	DeleteArray(CmdLine);
	DeleteObj(AppWnd);	
	DeleteObj(SystemFont);
	TheApp = 0;
}

bool GApp::GetOption(char *Dest, char Option)
{
	char WhiteSpace[] = " \t\r\n";
	char *c = CmdLine;
	while (c AND *c)
	{
		if (*c == '/' OR *c == '\\' OR *c == '-')
		{
			c++;
			if (*c == Option)
			{
				c++;
				if (*c)
				{
					// skip leading whitespace
					while (*c AND strchr(WhiteSpace, *c))
					{
						c++;
					}

					// write str out if they want it
					if (Dest)
					{
						char End = (*c == '\"') ? '\"' : ' ';
						if (End == '\"') c++;
						while (*c AND *c != End)
						{
							*Dest++ = *c++;
						}
						*Dest++ = 0;
					}
				}

				// yeah we got the option
				return TRUE;
			}
		}

		c = strchr(c, ' ');
		if (c) c++;
	}

	return FALSE;
}

void GApp::OnCmdLine(char *Cmd)
{
	DeleteArray(CmdLine);
	CmdLine = NewStr(Cmd);
	
	if (Cmd AND strlen(Cmd) > 0)
	{
		char WhiteSpace[] = " \r\n\t";
		List<char> l;

		// search for args
		for (char *c = Cmd; *c; )
		{
			// skip white
			while (strchr(WhiteSpace, *c)) c++;
			if (*c)
			{
				char End = (*c == '\"') ? '\"' : ' ';
				if (End == '\"') c++;
				char *Start = c;
				while (*c AND *c != End) c++;
				char *Str = NewStr(Start, (int)c-(int)Start);
				if (Str) l.Insert(Str);
				if (End == '\"') c++;
			}
		}

		if (l.GetItems() > 0)
		{
			// read args into an array
			char **Arg = NEW(char*[l.GetItems()]);
			if (Arg)
			{
				int n=0;
				for (char *a = l.First(); a; a = l.Next())
				{
					Arg[n++] = a;
				}

				// call the client
				OnArgs(l.GetItems(), Arg);

				// clean up
				for (n=0; n<l.GetItems(); n++)
				{
					DeleteArray(Arg[n]);
				}
				DeleteArray(Arg);
			}
		}
	}
}

void GApp::OnArgs(int Args, char **Arg)
{
	if (Arg)
	{
		List<char> Files;
		char File[256] = "";

		for (int i=0; i<Args; i++)
		{
			if (strlen(File) == 0)
			{
				strcpy(File, Arg[i]);
				if (FileExists(File))
				{
					Files.Insert(NewStr(File));
					File[0] = 0;
				}
			}
			else
			{
				strcat(File, " ");
				strcat(File, Arg[i]);
				if (FileExists(File))
				{
					Files.Insert(NewStr(File));
					File[0] = 0;
				}
			}
		}

		if (Files.GetItems() > 0)
		{
			OnReceiveFiles(Files);
		}

		for (char *s = Files.First(); s; s = Files.Next())
		{
			DeleteArray(s);
		}
	}
}

void GApp::OnReceiveFiles(List<char> &Files)
{
	if (AppWnd)
	{
		AppWnd->OnReceiveFiles(Files);
	}
}

bool GApp::Run(bool Loop)
{
	return false;
}

void GApp::Exit(int Code)
{
	DeleteObj(AppWnd);
	exit(-1);
}

//////////////////////////////////////////////////////////////////////////////
GSemaphore::GSemaphore()
{
	_Thread = 0;
	_Count = 0;

	#ifdef WIN32
	InitializeCriticalSection(&_Section);
	#endif
}

GSemaphore::~GSemaphore()
{
	#ifdef WIN32
	DeleteCriticalSection(&_Section);
	#endif
}

bool GSemaphore::_Lock()
{
	bool Status = false;
	#if defined WIN32
	EnterCriticalSection(&_Section);
	int ThisThread = GetCurrentThreadId();
	if (ThisThread == _Thread OR
		_Count == 0)
	{
		_Count++;
		_Thread = ThisThread;
		Status = true;
	}
	LeaveCriticalSection(&_Section);
	#else
	ASSERT(0);
	#endif
	return Status;
}

bool GSemaphore::Lock()
{
	while (NOT _Lock())
	{
		LgiSleep(10);
	}

	return true;
}

int GSemaphore::LockWithTimeout(int Timeout)
{
	int Start = LgiCurrentTime();
	while (LgiCurrentTime() < Start + Timeout)
	{
		if (_Lock())
		{
			return true;
		}
	}

	return false;
}

void GSemaphore::Unlock()
{
	#ifdef WIN32
	EnterCriticalSection(&_Section);
	int ThisThread = GetCurrentThreadId();
	if (_Count > 0)
	{
		if (ThisThread == _Thread)
		{
			_Count--;
		}
		if (_Count == 0)
		{
			_Thread = 0;
		}
	}
	LeaveCriticalSection(&_Section);
	#else
	ASSERT(0);
	#endif
}

//////////////////////////////////////////////////////////////////////////////
uint ThreadEntryPoint(int i)
{
	GThread *Thread = (GThread*) i;
	if (Thread)
	{
		Thread->OnBeforeMain();
		int Status = Thread->Main();
		Thread->OnAfterMain();
		// _endthreadex(Status);

		if (Thread->DeleteOnExit)
		{
			DeleteObj(Thread);
		}
	}

	return 0;
}

GThread::GThread()
{
	ASSERT(0);
}

GThread::~GThread()
{
}

bool GThread::IsExited()
{
	return false;
}

bool GThread::IsRunning()
{
	return false;
}

void GThread::Run(bool b)
{
}

void GThread::Terminate()
{
}

int32 GThread::ExitCode()
{
	return 0;
}

int GThread::Main()
{
	return 0;
}

int GThread::Priority()
{
	return 0;
}

void GThread::Priority(int p)
{
}

//////////////////////////////////////////////////////////////////////////////
int GTrayIcon::Id = 1;

GTrayIcon::GTrayIcon(int icons)
{
}

GTrayIcon::~GTrayIcon()
{
}

bool GTrayIcon::LoadIcon(char *Str, int Index)
{
	return FALSE;
}

bool GTrayIcon::Visible()
{
	return 0;
}

void GTrayIcon::Visible(bool v)
{
}

int GTrayIcon::Value()
{
	return Val;
}

void GTrayIcon::Value(int v)
{
	Val = v;
}

int GTrayIcon::OnEvent(GMessage *Message)
{
	return 0;
}

void GTrayIcon::OnMouseClick(GMouse &m)
{
	// override to do something useful
}

//////////////////////////////////////////////////////////////////////
GPrinter::GPrinter()
{
}

GPrinter::~GPrinter()
{
}

bool GPrinter::Browse(GView *Parent)
{
	return 0;
}

#define MAGIC_PRINTDLG					0xAAFF0100
#define MAGIC_DEVMODE					0xAAFF0101
#define MAGIC_DEVNAMES					0xAAFF0102

bool GPrinter::Serialize(pchar &Str, bool Write)
{
	return false;
}

///////////////////////////////////////////////////////////////////////////////
GThreadSem::GThreadSem()
{
	Count = 0;
	ThreadId = 0;
}

bool GThreadSem::Lock(int Timeout)
{
	ASSERT(0);

	ulong CurThread = 0;
	if (Count == 0 OR
		ThreadId == CurThread)
	{
		// Ok either no one has it locked
		// or we do...
		Count++;
		ThreadId = CurThread;
		return true;
	}
	else
	{
		// another thread has it locked...
		// lets wait around for a bit
		int Start = clock();
		while (Count > 0)
		{
			if (Timeout >= 0 AND
				clock() > Start + Timeout)
			{
				// timeout expired
				break;
			}

			// give the other thread a chance to run
			LgiSleep(100);
		}

		if (Count == 0)
		{
			// The sem was unlocked by the other thread
			// and we can grab it
			Count++;
			ThreadId = CurThread;
			return true;
		}

		// otherwise the timeout expired and we
		// failed to get the sem
	}

	return false;
}

void GThreadSem::Unlock()
{
	ASSERT(0);
	ulong CurThread = 0;
	if (Count > 0 AND
		ThreadId == CurThread)
	{
		Count--;
		if (Count == 0)
		{
			ThreadId = 0;
		}
	}
}
