/*hdr
**	FILE:		Memory.h
**	AUTHOR:		Matthew Allen
**	DATE:		30/11/93
**	DESCRIPTION:	Memory subsystem header
**
**
**	Copyright (C) 1995, Matthew Allen
**		fret@ozemail.com.au
*/

#ifndef __MEMORY_H
#define __MEMORY_H

#include <string.h>
#include "LibDefs.h"
#include "LgiOsDefs.h"

LgiFunc bool LgiCheckHeap();

#ifdef __DEBUG

	#define MEMORY_DEBUG

	LgiFunc char	*_vmem_file;
	LgiFunc int		_vmem_line;

	LgiFunc void	*_vmem_alloc(size_t Size, char *file, int line);
	LgiFunc void	_vmem_free(void *p);
	void *operator	new(unsigned size, char *file, int line);
	void *operator	new[](unsigned size, char *file, int line);
	void operator	delete(void *p);
	void operator	delete(void *p, char *file, int line);

	#define NEW(obj)			new(__FILE__, __LINE__) obj
	#define DeleteObj(obj)		if (obj) { _vmem_file = __FILE__; _vmem_line = __LINE__; delete obj; obj = 0; }
	#define DeleteArray(obj)	if (obj) { _vmem_file = __FILE__; _vmem_line = __LINE__; delete [] obj ; obj = 0; }

#else

	#define NEW(obj)			new obj
	#define DeleteObj(obj)		if (obj) { delete obj; obj = 0; }
	#define DeleteArray(obj)	if (obj) { delete [] obj; obj = 0; }

#endif

#endif
