#include "Lgi.h"

//////////////////////////////////////////////////////////////////////////////
int GTrayIcon::Id = 1;
int GTrayIcon::TrayCreateMsg = 0;

GTrayIcon::GTrayIcon(int icons)
{
	ZeroObj(TrayIcon);
	Val = 0;
	Msg = WM_TRAY_NOTIFY;
	Notify = 0;
	MyId = 0;
	Icons = max(icons, 1);
	hIcon = NEW(HICON[Icons]);
	TrayCreateMsg = RegisterWindowMessage(TEXT("TaskbarCreated"));
}

GTrayIcon::~GTrayIcon()
{
	Visible(FALSE);

	if (hIcon)
	{
		for (int i=0; i<Icons; i++)
		{
			// DeleteObject(hIcon[i]);
		}

		DeleteArray(hIcon);
	}
}

bool GTrayIcon::LoadIcon(char *Str, int Index)
{
	if (hIcon AND Index >= 0 AND Index < Icons)
	{
		hIcon[Index] = ::LoadIcon(hAppInst(), Str);
		return hIcon[Index] != NULL;
	}

	return FALSE;
}

bool GTrayIcon::Visible()
{
	return TrayIcon.cbSize != 0;
}

void GTrayIcon::Visible(bool v)
{
	if (Visible() != v)
	{
		if (v)
		{
			if (Notify AND hIcon)
			{
				ZeroObj(TrayIcon);
				TrayIcon.cbSize = sizeof(TrayIcon);
				TrayIcon.hWnd = Notify->Handle();
				TrayIcon.uID = MyId = Id++;
				TrayIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
				TrayIcon.uCallbackMessage = Msg;
				TrayIcon.hIcon = hIcon[Val];
				strncpy(TrayIcon.szTip, Name(), sizeof(TrayIcon.szTip));

				Shell_NotifyIcon(NIM_ADD, &TrayIcon);
			}
		}
		else
		{
			Shell_NotifyIcon(NIM_DELETE, &TrayIcon);
			ZeroObj(TrayIcon);
		}
	}
}

int GTrayIcon::Value()
{
	return Val;
}

void GTrayIcon::Value(int v)
{
	Val = v;

	if (Visible() AND hIcon)
	{
		ZeroObj(TrayIcon);
		TrayIcon.cbSize = sizeof(TrayIcon);
		TrayIcon.hWnd = Notify->Handle();
		TrayIcon.uID = MyId;
		TrayIcon.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
		TrayIcon.uCallbackMessage = Msg;
		TrayIcon.hIcon = hIcon[Val];
		strncpy(TrayIcon.szTip, Name(), sizeof(TrayIcon.szTip));

		Shell_NotifyIcon(NIM_MODIFY, &TrayIcon);
	}
}

int GTrayIcon::OnEvent(GMessage *Message)
{
	if (MsgCode(Message) == Msg AND
		MsgA(Message) == MyId)
	{
		// got a notification from the icon
		GMouse m;
		ZeroObj(m);
		switch (MsgB(Message))
		{
			case WM_LBUTTONDBLCLK:
			case WM_LBUTTONDOWN:
			case WM_RBUTTONDBLCLK:
			case WM_RBUTTONDOWN:
			case WM_MBUTTONDBLCLK:
			case WM_MBUTTONDOWN:
			{
				m.Down(true);
				break;
			}
		}

		switch (MsgB(Message))
		{
			case WM_LBUTTONDBLCLK:
			case WM_LBUTTONDOWN:
			case WM_LBUTTONUP:
			{
				m.Flags = MK_LEFT;
				break;
			}
			case WM_RBUTTONDBLCLK:
			case WM_RBUTTONDOWN:
			case WM_RBUTTONUP:
			{
				m.Flags = MK_RIGHT;
				break;
			}
			case WM_MBUTTONDBLCLK:
			case WM_MBUTTONDOWN:
			case WM_MBUTTONUP:
			{
				m.Flags = MK_MIDDLE;
				break;
			}
		}

		switch (MsgB(Message))
		{
			case WM_LBUTTONDBLCLK:
			case WM_RBUTTONDBLCLK:
			case WM_MBUTTONDBLCLK:
			{
				m.Double(true);
				break;
			}
		}

		OnMouseClick(m);
	}
	else if (MsgCode(Message) == TrayCreateMsg)
	{
		// explorer crashed... reinit the icon
		TrayIcon.cbSize = 0; // we're not visible
		Visible(true);
	}

	return 0;
}

void GTrayIcon::OnMouseClick(GMouse &m)
{
	// override to do something useful
}

